Index: /trunk/admin/configuration.php
===================================================================
--- /trunk/admin/configuration.php	(revision 20)
+++ /trunk/admin/configuration.php	(revision 21)
@@ -16,5 +16,5 @@
  *                                                                         *
  ***************************************************************************/
- 
+
 include_once( './include/isadmin.inc.php' );
 	
@@ -49,5 +49,6 @@
 if ( isset( $_POST['submit'] ) )
 {
-  //purge de la table des session si demandé
+  $int_pattern = '/^\d+$/';
+  // empty session table if asked
   if ( $_POST['empty_session_table'] == 1 )
   {
@@ -80,6 +81,6 @@
   }
   // periods must be integer values, they represents number of days
-  if ( !is_int( $_POST['short_period'] )
-       or !is_int( $_POST['long_period'] ) )
+  if ( !preg_match( $int_pattern, $_POST['short_period'] )
+       or !preg_match( $int_pattern, $_POST['long_period'] ) )
   {
     array_push( $error, $lang['err_periods'] );
@@ -95,5 +96,5 @@
   }
   // session_id size must be an integer between 4 and 50
-  if ( !is_int( $_POST['session_id_size'] )
+  if ( !preg_match( $int_pattern, $_POST['session_id_size'] )
        or $_POST['session_id_size'] < 4
        or $_POST['session_id_size'] > 50 )
@@ -102,5 +103,5 @@
   }
   // session_time must be an integer between 5 and 60, in minutes
-  if ( !is_int( $_POST['session_time'] )
+  if ( !preg_match( $int_pattern, $_POST['session_time'] )
        or $_POST['session_time'] < 5
        or $_POST['session_time'] > 60 )
@@ -109,5 +110,5 @@
   }
   // max_user_listbox must be an integer between 0 and 255 included
-  if ( !is_int( $_POST['max_user_listbox'] )
+  if ( !preg_match( $int_pattern, $_POST['max_user_listbox'] )
        or $_POST['max_user_listbox'] < 0
        or $_POST['max_user_listbox'] > 255 )
@@ -117,5 +118,5 @@
   // the number of comments per page must be an integer between 5 and 50
   // included
-  if ( !is_int( $_POST['nb_comment_page'] )
+  if ( !preg_match( $int_pattern, $_POST['nb_comment_page'] )
        or $_POST['nb_comment_page'] < 5
        or $_POST['nb_comment_page'] > 50 )
@@ -124,5 +125,5 @@
   }
   // the maximum upload filesize must be an integer between 10 and 1000
-  if ( !is_int( $_POST['upload_maxfilesize'] )
+  if ( !preg_match( $int_pattern, $_POST['upload_maxfilesize'] )
        or $_POST['upload_maxfilesize'] < 10
        or $_POST['upload_maxfilesize'] > 1000 )
@@ -132,5 +133,5 @@
   // the maximum width of uploaded pictures must be an integer superior to
   // 10
-  if ( !is_int( $_POST['upload_maxwidth'] )
+  if ( !preg_match( $int_pattern, $_POST['upload_maxwidth'] )
        or $_POST['upload_maxwidth'] < 10 )
   {
@@ -139,5 +140,5 @@
   // the maximum height  of uploaded pictures must be an integer superior to
   // 10
-  if ( !is_int( $_POST['upload_maxheight'] )
+  if ( !preg_match( $int_pattern, $_POST['upload_maxheight'] )
        or $_POST['upload_maxheight'] < 10 )
   {
@@ -146,5 +147,5 @@
   // the maximum width of uploaded thumbnails must be an integer superior to
   // 10
-  if ( !is_int( $_POST['upload_maxwidth_thumbnail'] )
+  if ( !preg_match( $int_pattern, $_POST['upload_maxwidth_thumbnail'] )
        or $_POST['upload_maxwidth_thumbnail'] < 10 )
   {
@@ -153,33 +154,27 @@
   // the maximum width of uploaded thumbnails must be an integer superior to
   // 10
-  if ( !is_int( $_POST['upload_maxheight_thumbnail'] )
+  if ( !preg_match( $int_pattern, $_POST['upload_maxheight_thumbnail'] )
        or $_POST['upload_maxheight_thumbnail'] < 10 )
   {
     array_push( $error, $lang['conf_err_upload_maxheight_thumbnail'] );
   }
-  $test = '';
-  if ( is_int( $test ) ) echo 'salut'; exit();
-  if ( $_POST['maxwidth'] != '' )
-  {
-    if ( !ereg( "^[0-9]{2,}$", $_POST['maxwidth'] )
-         or $_POST['maxwidth'] < 50 )
-    {
-      $error[$i++] = $lang['err_maxwidth'];
-    }
-  }
-  if ( $_POST['maxheight'] != '' )
-  {
-    if ( !ereg( "^[0-9]{2,}$", $_POST['maxheight'] )
-         or $_POST['maxheight'] < 50 )
-    {
-      $error[$i++] = $lang['err_maxheight'];
-    }
-  }
-  // on met à jour les paramètres de l'application
-  // dans le cas où il n'y aucune erreurs
-  if ( sizeof( $error ) == 0 )
-  {
-    mysql_query( 'delete from '.PREFIX_TABLE.'config;' );
-    $query = 'insert into '.PREFIX_TABLE.'config';
+
+  if ( $_POST['maxwidth'] != ''
+       and ( !preg_match( $int_pattern, $_POST['maxwidth'] )
+             or $_POST['maxwidth'] < 50 ) )
+  {
+    array_push( $error, $lang['err_maxwidth'] );
+  }
+  if ( $_POST['maxheight']
+       and ( !preg_match( $int_pattern, $_POST['maxheight'] )
+             or $_POST['maxheight'] < 50 ) )
+  {
+    array_push( $error, $lang['err_maxheight'] );
+  }
+  // updating configuraiton if no error found
+  if ( count( $error ) == 0 )
+  {
+    mysql_query( 'DELETE FROM '.PREFIX_TABLE.'config;' );
+    $query = 'INSERT INTO '.PREFIX_TABLE.'config';
     $query.= ' (';
     foreach ( $conf_infos as $i => $conf_info ) {
@@ -188,5 +183,5 @@
     }
     $query.= ')';
-    $query.= ' values';
+    $query.= ' VALUES';
     $query.= ' (';
     foreach ( $conf_infos as $i => $conf_info ) {
@@ -261,13 +256,10 @@
 }
 //----------------------------------------------------- template initialization
-$sub = $vtp->Open( '../template/'.$user['template'].
-                   '/admin/configuration.vtp' );
-// language
-$vtp->setGlobalVar( $sub, 'conf_confirmation',  $lang['conf_confirmation'] );
-$vtp->setGlobalVar( $sub, 'remote_site',        $lang['remote_site'] );
-$vtp->setGlobalVar( $sub, 'delete',             $lang['delete'] );
-$vtp->setGlobalVar( $sub, 'conf_remote_site_delete_info',
-                    $lang['conf_remote_site_delete_info'] );
-$vtp->setGlobalVar( $sub, 'submit',             $lang['submit'] );
+$sub = $vtp->Open(
+  '../template/'.$user['template'].'/admin/configuration.vtp' );
+
+$tpl = array( 'conf_confirmation','remote_site','delete',
+              'conf_remote_site_delete_info','submit' );
+templatize_array( $tpl, 'lang', $sub );
 //-------------------------------------------------------------- errors display
 if ( sizeof( $error ) != 0 )
@@ -346,5 +338,4 @@
 $vtp->setVar( $sub, 'radio.option', $lang['conf_general_access_1'] );
 $checked = '';
-echo $access.'<br />';
 if ( $access == 'free' )
 {
Index: /trunk/admin/group_list.php
===================================================================
--- /trunk/admin/group_list.php	(revision 21)
+++ /trunk/admin/group_list.php	(revision 21)
@@ -0,0 +1,135 @@
+<?php
+/***************************************************************************
+ *                                 group.php                               *
+ *                            -------------------                          *
+ *   application          : PhpWebGallery 1.3                              *
+ *   author               : Pierrick LE GALL <pierrick@z0rglub.com>        *
+ *                                                                         *
+ ***************************************************************************/
+
+/***************************************************************************
+ *                                                                         *
+ *   This program is free software; you can redistribute it and/or modify  *
+ *   it under the terms of the GNU General Public License as published by  *
+ *   the Free Software Foundation;                                         *
+ *                                                                         *
+ ***************************************************************************/
+include_once( './include/isadmin.inc.php' );
+//----------------------------------------------------- template initialization
+$sub = $vtp->Open( '../template/'.$user['template'].'/admin/group_list.vtp' );
+$tpl = array( 'group_add','add','listuser_permission','delete',
+              'group_confirm','yes','no','group_list_title' );
+templatize_array( $tpl, 'lang', $sub );
+//-------------------------------------------------------------- delete a group
+$error = array();
+if ( isset ( $_GET['delete'] ) and is_numeric( $_GET['delete'] ) )
+{
+  $query = 'SELECT name';
+  $query.= ' FROM '.PREFIX_TABLE.'groups';
+  $query.= ' WHERE id = '.$_GET['delete'];
+  $query.= ';';
+  $row = mysql_fetch_array( mysql_query( $query ) );
+  // confirm group deletion ?
+  if ( $_GET['confirm'] != 1 )
+  {
+    $vtp->addSession( $sub, 'deletion' );
+    $vtp->setVar( $sub, 'deletion.name', $row['name'] );
+    $yes_url = './admin.php?page=group&amp;delete='.$_GET['delete'];
+    $yes_url.= '&amp;confirm=1';
+    $vtp->setVar( $sub, 'deletion.yes_url', add_session_id( $yes_url ) );
+    $no_url = './admin.php?page=group';
+    $vtp->setVar( $sub, 'deletion.no_url', add_session_id( $no_url ) );
+    $vtp->closeSession( $sub, 'deletion' );
+  }
+  // group deletion confirmed
+  else
+  {
+    $vtp->addSession( $sub, 'confirmation' );
+    $query = 'SELECT COUNT(*) AS nb_result';
+    $query.= ' FROM '.PREFIX_TABLE.'groups';
+    $query.= ' WHERE id = '.$_GET['delete'];
+    $query.= ';';
+    $row2 = mysql_fetch_array( mysql_query( $query ) );
+    if ( $row2['nb_result'] > 0 )
+    {
+      delete_group( $_GET['delete'] );
+      $vtp->setVar( $sub, 'confirmation.class', 'info' );
+      $info = '"'.$row['name'].'" '.$lang['listuser_info_deletion'];
+      $vtp->setVar( $sub, 'confirmation.info', $info );
+    }
+    else
+    {
+      $vtp->setVar( $sub, 'confirmation.class', 'erreur' );
+      $vtp->setVar( $sub, 'confirmation.info', $lang['group_err_unknown'] );
+    }
+    $vtp->closeSession( $sub, 'confirmation' );
+  }
+}
+//----------------------------------------------------------------- add a group
+if ( isset( $_POST['submit'] ) )
+{
+  if ( preg_match( "/'/", $_POST['name'] )
+       or preg_match( '/"/', $_POST['name'] ) )
+  {
+    array_push( $error, $lang['group_add_error1'] );
+  }
+  if ( count( $error ) == 0 )
+  {
+    // is the group not already existing ?
+    $query = 'SELECT id';
+    $query.= ' FROM '.PREFIX_TABLE.'groups';
+    $query.= " WHERE name = '".$_POST['name']."'";
+    $query.= ';';
+    $result = mysql_query( $query );
+    if ( mysql_num_rows( $result ) > 0 )
+    {
+      array_push( $error, $lang['group_add_error2'] );
+    }
+  }
+  if ( count( $error ) == 0 )
+  {
+    // creating the group
+    $query = ' INSERT INTO '.PREFIX_TABLE.'groups';
+    $query.= " (name) VALUES ('".$_POST['name']."')";
+    $query.= ';';
+    mysql_query( $query );
+  }
+}
+//-------------------------------------------------------------- errors display
+if ( sizeof( $error ) != 0 )
+{
+  $vtp->addSession( $sub, 'errors' );
+  for ( $i = 0; $i < sizeof( $error ); $i++ )
+  {
+    $vtp->addSession( $sub, 'li' );
+    $vtp->setVar( $sub, 'li.li', $error[$i] );
+    $vtp->closeSession( $sub, 'li' );
+  }
+  $vtp->closeSession( $sub, 'errors' );
+}
+//----------------------------------------------------------------- groups list
+$vtp->addSession( $sub, 'groups' );
+
+$query = 'SELECT id,name';
+$query.= ' FROM '.PREFIX_TABLE.'groups';
+$query.= ' ORDER BY id ASC';
+$query.= ';';
+$result = mysql_query( $query );
+while ( $row = mysql_fetch_array( $result ) )
+{
+  $vtp->addSession( $sub, 'group' );
+  $vtp->setVar( $sub, 'group.name', $row['name'] );
+  $url = './admin.php?page=group_perm&amp;group_id='.$row['id'];
+  $vtp->setVar( $sub, 'group.permission_url', add_session_id( $url ) );
+  $url = './admin.php?page=group&amp;delete='.$row['id'];
+  $vtp->setVar( $sub, 'group.deletion_url', add_session_id( $url ) );
+  $vtp->closeSession( $sub, 'group' );
+}
+
+$vtp->closeSession( $sub, 'groups' );
+//------------------------------------------------------- create new group form
+$action = './admin.php?'.$_SERVER['QUERY_STRING'];
+$vtp->setVar( $sub, 'form_action', $action );
+//----------------------------------------------------------- sending html code
+$vtp->Parse( $handle , 'sub', $sub );
+?>
Index: /trunk/admin/group_perm.php
===================================================================
--- /trunk/admin/group_perm.php	(revision 21)
+++ /trunk/admin/group_perm.php	(revision 21)
@@ -0,0 +1,104 @@
+<?php
+/***************************************************************************
+ *                               group_perm.php                             *
+ *                            ------------------                           *
+ *   application          : PhpWebGallery 1.3                              *
+ *   author               : Pierrick LE GALL <pierrick@z0rglub.com>        *
+ *                                                                         *
+ ***************************************************************************/
+
+/***************************************************************************
+ *                                                                         *
+ *   This program is free software; you can redistribute it and/or modify  *
+ *   it under the terms of the GNU General Public License as published by  *
+ *   the Free Software Foundation;                                         *
+ *                                                                         *
+ ***************************************************************************/
+include_once( './include/isadmin.inc.php' );
+//----------------------------------------------------- template initialization
+$sub = $vtp->Open( '../template/'.$user['template'].'/admin/group_perm.vtp' );
+$error = array();
+$tpl = array( 'permuser_authorized','permuser_forbidden','submit',
+              'permuser_parent_forbidden','permuser_info_message',
+              'adduser_info_back' );
+templatize_array( $tpl, 'lang', $sub );
+//--------------------------------------------------------------------- updates
+if ( isset( $_POST['submit'] ) )
+{
+  // cleaning the user_access table for this group
+  $query = 'DELETE FROM '.PREFIX_TABLE.'group_access';
+  $query.= ' WHERE group_id = '.$_GET['group_id'];
+  $query.= ';';
+  mysql_query( $query );
+  // selecting all private categories
+  $query = 'SELECT id';
+  $query.= ' FROM '.PREFIX_TABLE.'categories';
+  $query.= " WHERE status = 'private'";
+  $query.= ';';
+  $result = mysql_query( $query );
+  while ( $row = mysql_fetch_array( $result ) )
+  {
+    $radioname = 'access-'.$row['id'];
+    if ( $_POST[$radioname] == 0 )
+    {
+      $query = 'INSERT INTO '.PREFIX_TABLE.'group_access';
+      $query.= ' (group_id,cat_id) VALUES';
+      $query.= ' ('.$_GET['group_id'].','.$row['id'].')';
+      $query.= ';';
+      mysql_query ( $query );
+    }
+  }
+  $vtp->addSession( $sub, 'confirmation' );
+  $url = './admin.php?page=group_list';
+  $vtp->setVar( $sub, 'confirmation.back_url', add_session_id( $url ) );
+  $vtp->closeSession( $sub, 'confirmation' );
+}
+//---------------------------------------------------------------- form display
+$restrictions = get_group_restrictions( $_GET['group_id'] );
+$action = './admin.php?page=group_perm&amp;group_id='.$_GET['group_id'];
+$vtp->setVar( $sub, 'action', add_session_id( $action ) );
+// only private categories are listed
+$query = 'SELECT id';
+$query.= ' FROM '.PREFIX_TABLE.'categories';
+$query.= " WHERE status = 'private'";
+$query.= ';';
+$result = mysql_query( $query );
+while ( $row = mysql_fetch_array( $result ) )
+{
+  $vtp->addSession( $sub, 'category' );
+  $vtp->setVar( $sub, 'category.id', $row['id'] );
+  // Is the group allowed to access this category
+  $is_group_allowed = is_group_allowed( $row['id'], $restrictions );
+  if ( $is_group_allowed == 0 )
+  {
+    $vtp->setVar( $sub, 'category.color', 'green' );
+  }
+  else
+  {
+    $vtp->setVar( $sub, 'category.color', 'red' );
+  }
+  // category name
+  $cat_infos = get_cat_info( $row['id'] );
+  $name = get_cat_display_name( $cat_infos['name'],' &gt; ',
+                                'font-weight:bold;' );
+  $vtp->setVar( $sub, 'category.name', $name );
+  // any subcat forbidden for this group ?
+  if ( $is_group_allowed == 2 )
+  {
+    $vtp->addSession( $sub, 'parent_forbidden' );
+    $vtp->closeSession( $sub, 'parent_forbidden' );
+  }
+  // forbidden or authorized access ?
+  if ( $is_group_allowed == 0 or $is_group_allowed == 2 )
+  {
+    $vtp->setVar( $sub, 'category.authorized_checked', ' checked="checked"' );
+  }
+  else
+  {
+    $vtp->setVar( $sub, 'category.forbidden_checked', ' checked="checked"' );
+  }
+  $vtp->closeSession( $sub, 'category' );
+}
+//----------------------------------------------------------- sending html code
+$vtp->Parse( $handle , 'sub', $sub );
+?>
Index: /trunk/admin/include/functions.php
===================================================================
--- /trunk/admin/include/functions.php	(revision 20)
+++ /trunk/admin/include/functions.php	(revision 21)
@@ -102,11 +102,15 @@
     delete_image( $row['id'] );
   }
-		
-  // destruction of the restrictions linked to the category
-  $query = 'DELETE FROM '.PREFIX_TABLE.'restrictions';
+
+  // destruction of the access linked to the category
+  $query = 'DELETE FROM '.PREFIX_TABLE.'user_access';
   $query.= ' WHERE cat_id = '.$id;
   $query.= ';';
   mysql_query( $query );
-		
+  $query = 'DELETE FROM '.PREFIX_TABLE.'group_access';
+  $query.= ' WHERE cat_id = '.$id;
+  $query.= ';';
+  mysql_query( $query );
+
   // destruction of the sub-categories
   $query = 'SELECT id';
@@ -119,5 +123,5 @@
     delete_category( $row['id'] );
   }
-		
+
   // destruction of the category
   $query = 'DELETE FROM '.PREFIX_TABLE.'categories';
@@ -157,16 +161,30 @@
 // The delete_user function delete a user identified by the $user_id
 // It also deletes :
-//     - all the restrictions linked to this user
+//     - all the access linked to this user
+//     - all the links to any group
 //     - all the favorites linked to this user
+//     - all sessions linked to this user
 function delete_user( $user_id )
 {
-  // destruction of the restrictions linked to the user
-  $query = 'DELETE FROM '.PREFIX_TABLE.'restrictions';
-  $query.= ' WHERE user_id = '.$user_id;
-  $query.= ';';
-  mysql_query( $query );
-		
+  // destruction of the access linked to the user
+  $query = 'DELETE FROM '.PREFIX_TABLE.'user_access';
+  $query.= ' WHERE user_id = '.$user_id;
+  $query.= ';';
+  mysql_query( $query );
+
+  // destruction of the group links for this user
+  $query = 'DELETE FROM '.PREFIX_TABLE.'user_group';
+  $query.= ' WHERE user_id = '.$user_id;
+  $query.= ';';
+  mysql_query( $query );
+
   // destruction of the favorites associated with the user
   $query = 'DELETE FROM '.PREFIX_TABLE.'favorites';
+  $query.= ' WHERE user_id = '.$user_id;
+  $query.= ';';
+  mysql_query( $query );
+
+  // destruction of the sessions linked with the user
+  $query = 'DELETE FROM '.PREFIX_TABLE.'sessions';
   $query.= ' WHERE user_id = '.$user_id;
   $query.= ';';
@@ -179,5 +197,30 @@
   mysql_query( $query );
 }
-	
+
+// delete_group deletes a group identified by its $group_id.
+// It also deletes :
+//     - all the access linked to this group
+//     - all the links between this group and any user
+function delete_group( $group_id )
+{
+  // destruction of the access linked to the group
+  $query = 'DELETE FROM '.PREFIX_TABLE.'group_access';
+  $query.= ' WHERE group_id = '.$group_id;
+  $query.= ';';
+  mysql_query( $query );
+
+  // destruction of the group links for this group
+  $query = 'DELETE FROM '.PREFIX_TABLE.'user_group';
+  $query.= ' WHERE group_id = '.$group_id;
+  $query.= ';';
+  mysql_query( $query );
+
+  // destruction of the group
+  $query = 'DELETE FROM '.PREFIX_TABLE.'groups';
+  $query.= ' WHERE id = '.$group_id;
+  $query.= ';';
+  mysql_query( $query );
+}
+
 // The check_favorites function deletes all the favorites of a user if he is
 // not allowed to see them (the category or an upper category is restricted
Index: /trunk/admin/include/isadmin.inc.php
===================================================================
--- /trunk/admin/include/isadmin.inc.php	(revision 20)
+++ /trunk/admin/include/isadmin.inc.php	(revision 21)
@@ -15,11 +15,9 @@
  *                                                                         *
  ***************************************************************************/
-define( PREFIXE_INCLUDE, '.' );
+define( PREFIX_INCLUDE, '.' );
 
 include_once( '../include/config.inc.php' );
 include_once( '../include/user.inc.php' );
 include( './include/functions.php' );
-
-$conf['lien_puce'] = $conf['repertoire_image'].'puce.gif';
 
 $isadmin = true;
Index: /trunk/admin/user_list.php
===================================================================
--- /trunk/admin/user_list.php	(revision 20)
+++ /trunk/admin/user_list.php	(revision 21)
@@ -18,30 +18,16 @@
 //----------------------------------------------------- template initialization
 $sub = $vtp->Open( '../template/'.$user['template'].'/admin/user_list.vtp' );
-// language
-$vtp->setGlobalVar( $sub, 'listuser_confirm',  $lang['listuser_confirm'] );
-$vtp->setGlobalVar( $sub, 'listuser_modify_hint',
-                    $lang['listuser_modify_hint'] );
-$vtp->setGlobalVar( $sub, 'listuser_modify', $lang['listuser_modify'] );
-$vtp->setGlobalVar( $sub, 'listuser_permission',
-                    $lang['listuser_permission'] );
-$vtp->setGlobalVar( $sub, 'listuser_permission_hint',
-                    $lang['listuser_permission_hint'] );
-$vtp->setGlobalVar( $sub, 'listuser_delete_hint',
-                    $lang['listuser_delete_hint'] );
-$vtp->setGlobalVar( $sub, 'listuser_delete',   $lang['listuser_delete'] );
-$vtp->setGlobalVar( $sub, 'yes',               $lang['yes'] );
-$vtp->setGlobalVar( $sub, 'no',                $lang['no'] );
-$vtp->setGlobalVar( $sub, 'listuser_button_all',
-                    $lang['listuser_button_all'] );
-$vtp->setGlobalVar( $sub, 'listuser_button_invert',
-                    $lang['listuser_button_invert'] );
-$vtp->setGlobalVar( $sub, 'listuser_button_create_address',
-                    $lang['listuser_button_create_address'] );
+$tpl = array( 'listuser_confirm','listuser_modify_hint','listuser_modify',
+              'listuser_permission','listuser_permission_hint',
+              'listuser_delete_hint','listuser_delete','yes','no',
+              'listuser_button_all','listuser_button_invert',
+              'listuser_button_create_address' );
+templatize_array( $tpl, 'lang', $sub );
 //--------------------------------------------------------------- delete a user
 if ( isset ( $_GET['delete'] ) and is_numeric( $_GET['delete'] ) )
 {
-  $query = 'select username';
-  $query.= ' from '.PREFIX_TABLE.'users';
-  $query.= ' where id = '.$_GET['delete'];
+  $query = 'SELECT username';
+  $query.= ' FROM '.PREFIX_TABLE.'users';
+  $query.= ' WHERE id = '.$_GET['delete'];
   $query.= ';';
   $row = mysql_fetch_array( mysql_query( $query ) );
@@ -65,7 +51,7 @@
          and $row['username'] != $conf['webmaster'] )
     {
-      $query = 'select count(*) as nb_result';
-      $query.= ' from '.PREFIX_TABLE.'users';
-      $query.= ' where id = '.$_GET['delete'];
+      $query = 'SELECT COUNT(*) AS nb_result';
+      $query.= ' FROM '.PREFIX_TABLE.'users';
+      $query.= ' WHERE id = '.$_GET['delete'];
       $query.= ';';
       $row2 = mysql_fetch_array( mysql_query( $query ) );
@@ -103,7 +89,7 @@
   $vtp->setVar( $sub, 'users.form_action', $action );
 
-  $query = 'select id,username,status,mail_address';
-  $query.= ' from '.PREFIX_TABLE.'users';
-  $query.= ' order by status asc, username asc';
+  $query = 'SELECT id,username,status,mail_address';
+  $query.= ' FROM '.PREFIX_TABLE.'users';
+  $query.= ' ORDER BY status ASC, username ASC';
   $query.= ';';
   $result = mysql_query( $query );
@@ -123,14 +109,6 @@
       switch ( $row['status'] )
       {
-      case 'admin' :
-      {
-        $title.= $lang['adduser_status_admin'];
-        break;
-      }
-      case 'guest' :
-      {
-        $title.= $lang['adduser_status_guest'];
-        break;
-      }
+      case 'admin' : $title.= $lang['adduser_status_admin']; break;
+      case 'guest' : $title.= $lang['adduser_status_guest']; break;
       }
       $vtp->setVar( $sub, 'category.title', $title );
@@ -153,7 +131,4 @@
     {
       $vtp->setVar( $sub, 'user.color', 'green' );
-    }
-    if ( $row['username'] == 'guest' )
-    {
       $vtp->setVar( $sub, 'user.login', $lang['guest'] );
     }
@@ -180,5 +155,6 @@
     }
     // manage permission or not ?
-    if ( $row['username'] == $conf['webmaster'] )
+    if ( $row['username'] == $conf['webmaster']
+         and $user['username'] != $conf['webmaster'] )
     {
       $vtp->addSession( $sub, 'not_permission' );
@@ -188,5 +164,5 @@
     {
       $vtp->addSession( $sub, 'permission' );
-      $url = './admin.php?page=perm&amp;user_id='.$row['id'];
+      $url = './admin.php?page=user_perm&amp;user_id='.$row['id'];
       $vtp->setVar( $sub, 'permission.url', add_session_id( $url ) );
       $vtp->setVar( $sub, 'permission.login', $row['username'] );
@@ -216,7 +192,6 @@
     $mail_address = array();
     $i = 0;
-    $query = 'select';
-    $query.= ' id,mail_address';
-    $query.= ' from '.PREFIX_TABLE.'users';
+    $query = 'SELECT id,mail_address';
+    $query.= ' FROM '.PREFIX_TABLE.'users';
     $query.= ';';
     $result = mysql_query( $query );
Index: /trunk/admin/user_modify.php
===================================================================
--- /trunk/admin/user_modify.php	(revision 20)
+++ /trunk/admin/user_modify.php	(revision 21)
@@ -21,5 +21,6 @@
 $tpl = array( 'adduser_info_message', 'adduser_info_back', 'adduser_fill_form',
               'login', 'new', 'password', 'mail_address', 'adduser_status',
-              'submit', 'adduser_info_password_updated' );
+              'submit', 'adduser_info_password_updated','menu_groups',
+              'dissociate','adduser_associate' );
 templatize_array( $tpl, 'lang', $sub );
 //--------------------------------------------------------- form criteria check
@@ -35,5 +36,7 @@
 $query.= ';';
 $row = mysql_fetch_array( mysql_query( $query ) );
-
+$page['username'] = $row['username'];
+$page['status'] = $row['status'];
+$page['mail_address'] = $row['mail_address'];
 // user is not modifiable if :
 //   1. the selected user is the user "guest"
@@ -67,4 +70,32 @@
                           $_POST['password'] ) );
 }
+// association with groups management
+if ( isset( $_POST['submit'] ) )
+{
+  // deletion of checked groups
+  $query = 'SELECT id,name';
+  $query.= ' FROM '.PREFIX_TABLE.'groups';
+  $query.= ' ORDER BY id ASC';
+  $query.= ';';
+  $result = mysql_query( $query );
+  while ( $row = mysql_fetch_array( $result ) )
+  {
+    $dissociate = 'dissociate-'.$row['id'];
+    if ( $_POST[$dissociate] == 1 )
+    {
+      $query = 'DELETE FROM '.PREFIX_TABLE.'user_group';
+      $query.= ' WHERE user_id = '.$_GET['user_id'];
+      $query.= ' AND group_id ='.$row['id'];
+      $query.= ';';
+      mysql_query( $query );
+    }
+  }
+  // create a new association between the user and a group
+  $query = 'INSERT INTO '.PREFIX_TABLE.'user_group';
+  $query.= ' (user_id,group_id) VALUES';
+  $query.= ' ('.$_GET['user_id'].','.$_POST['associate'].')';
+  $query.= ';';
+  mysql_query( $query );
+}
 //-------------------------------------------------------------- errors display
 if ( sizeof( $error ) != 0 )
@@ -83,5 +114,5 @@
 {
   $vtp->addSession( $sub, 'confirmation' );
-  $vtp->setVar( $sub, 'confirmation.username', $row['username'] );
+  $vtp->setVar( $sub, 'confirmation.username', $page['username'] );
   $url = add_session_id( './admin.php?page=user_list' );
   $vtp->setVar( $sub, 'confirmation.url', $url );
@@ -92,5 +123,4 @@
     $vtp->closeSession( $sub, 'password_updated' );
   }
-  $display_form = false;
 }
 //------------------------------------------------------------------------ form
@@ -100,11 +130,13 @@
   $action = './admin.php?page=user_modify&amp;user_id='.$_GET['user_id'];
   $vtp->setVar( $sub, 'form.form_action', add_session_id( $action ) );
-  $vtp->setVar( $sub, 'form.user:username',     $row['username'] );
-  $vtp->setVar( $sub, 'form.user:password',     $_POST['password'] );
-  $vtp->setVar( $sub, 'form.user:mail_address', $_POST['mail_address'] );
-
-  if ( !isset( $_POST['status'] ) )
-  {
-    $_POST['status'] = 'guest';
+  $vtp->setVar( $sub, 'form.user:username',     $page['username'] );
+  if ( isset( $_POST['mail_address'] ) )
+  {
+    $page['mail_address'] = $_POST['mail_address'];
+  }
+  $vtp->setVar( $sub, 'form.user:mail_address', $page['mail_address'] );
+  if ( isset( $_POST['status'] ) )
+  {
+    $page['status'] = $_POST['status'];
   }
   $option = get_enums( PREFIX_TABLE.'users', 'status' );
@@ -115,5 +147,5 @@
     $vtp->setVar( $sub, 'status_option.option',
                   $lang['adduser_status_'.$option[$i]] );
-    if( $option[$i] == $_POST['status'] )
+    if( $option[$i] == $page['status'] )
     {
       $vtp->setVar( $sub, 'status_option.selected', ' selected="selected"' );
@@ -121,4 +153,47 @@
     $vtp->closeSession( $sub, 'status_option' );
   }
+  // groups linked with this user
+  $query = 'SELECT id,name';
+  $query.= ' FROM '.PREFIX_TABLE.'user_group, '.PREFIX_TABLE.'groups';
+  $query.= ' WHERE group_id = id';
+  $query.= ' AND user_id = '.$_GET['user_id'];
+  $query.= ';';
+  $result = mysql_query( $query );
+  $user_groups = array();
+  if ( mysql_num_rows( $result ) > 0 )
+  {
+    $vtp->addSession( $sub, 'groups' );
+    while ( $row = mysql_fetch_array( $result ) )
+    {
+      $vtp->addSession( $sub, 'group' );
+      $vtp->setVar( $sub, 'group.name', $row['name'] );
+      $vtp->setVar( $sub, 'group.dissociate_id', $row['id'] );
+      $vtp->closeSession( $sub, 'group' );
+      array_push( $user_groups, $row['id'] );
+    }
+    $vtp->closeSession( $sub, 'groups' );
+  }
+  // empty group not to take into account
+  $vtp->addSession( $sub, 'associate_group' );
+  $vtp->setVar( $sub, 'associate_group.value', 'undef' );
+  $vtp->setVar( $sub, 'associate_group.option', '' );
+  $vtp->closeSession( $sub, 'associate_group' );
+  // groups not linked yet to the user
+  $query = 'SELECT id,name';
+  $query.= ' FROM '.PREFIX_TABLE.'groups';
+  $query.= ' ORDER BY id ASC';
+  $query.= ';';
+  $result = mysql_query( $query );
+  while ( $row = mysql_fetch_array( $result ) )
+  {
+    if ( !in_array( $row['id'], $user_groups ) )
+    {
+      $vtp->addSession( $sub, 'associate_group' );
+      $vtp->setVar( $sub, 'associate_group.value', $row['id'] );
+      $vtp->setVar( $sub, 'associate_group.option', $row['name'] );
+      $vtp->closeSession( $sub, 'associate_group' );
+    }
+  }
+
   $url = add_session_id( './admin.php?page=user_list' );
   $vtp->setVar( $sub, 'form.url_back', $url );
